unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit, RXCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    DBFilenameEdit         : TFilenameEdit;
    ConvertButton          : TButton;
    RxLabel1               : TRxLabel;
    STypeRadioGroup        : TRadioGroup;

    procedure Convert (Sender : TObject);
    procedure ConvertMsb ;
    procedure ConvertTxt ;
    
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm    : TMainForm;
  szDBFile    : String;     //   
  szNewFile   : String;     //   
  tfDBFile    : TextFile;   //  
  tfNewFile   : TextFile;   //  
  //liFSize     : LongInt;    //   


implementation
{$R *.DFM}
uses
  StrUtils;

procedure TMainForm.Convert  (Sender : TObject);
begin

  if  STypeRadioGroup.Items[STypeRadioGroup.ItemIndex] = 'The Bat ! file ( msg )'
    then  ConvertMsb
    else  ConvertTxt;

end;


procedure TMainForm.ConvertMsb ;
var
  lnFile    : String;       //    
  lnTitle   : String;       //  html 
  iCounter  : Integer;      //   
  iECounter : Integer;      //    
  bTagOpen  : Boolean;      //     
  sSubject  : String;       // Subj 
  sDate     : String;       //   

const
  //      :)
  sHead1    = '<html>'#13#10 +
              '<head>'#13#10 +
              '<title>';
  sHead2    = '</title>'#13#10 +
              '</head>'#13#10 +
              '<body text="#000099" bgcolor="#C0C0C0" link="#0000EE" vlink="#551A8B" alink="#FF0000">'#13#10 +
              '<pre>'#13#10 +
              '<b><font color="#006600">';
  sHead3    = '</font></b>';

  sEnd      = '</pre>'#13#10 +
              '</body>'#13#10 +
              '</html>'#13#10;

  sTagOpen  = '<b><font color="#990000">';
  sTagClose = '</font></b>';

  //   
  sBOM      =  'Content-Transfer-Encoding:';

  //   
  sEOM      =  '@'#04#25 ;

  //  
  sAttach   =  'Content-Type: application';

  //  ,     
  aExcludes :array[0..9]of String = ('Message-Id:', 'Return-Path:',
                                     'X-Orcpt:', 'Status:', 'X-BAT-FILES:',
                                     'X-UIDL:',
                                     '-----=_NextPart', '------=_NextPart',
                                     'Content-Type: text/plain;',
                                     'Content-Transfer-Encoding:');

begin

    szDBFile   := DBFileNameEdit.Text;
    AssignFile (tfDBFile,szDBFile);
    Reset      (tfDBFile);

    iCounter    := 0;


    if Application.MessageBox('Process whith selected file ?','Confirmation',MB_OKCANCEL) = IDOK
    then begin

      while {FilePos(tfDBFile) < liFSize+1}not eof(tfDBFile) do
      begin

        lnFile   := '';
        sSubject := 'Subj  ';
        sDate    := 'Date  ';
        
        while Pos(sBOM,lnFile) <> 1 do   //     
        begin
        
          ReadLn(tfDBFile,lnFile);

          if  Pos('Subject:',lnFile) = 1
            then sSubject := ReplaceStr(lnFile, 'Subject:','');

          if  Pos('Date:',lnFile) =1
            then sDate    := ReplaceStr(lnFile, 'Date:','');

        end; {while Pos(sBOM,lnFile) <> 1}

        //   
        Inc(iCounter);
        szNewFile  := 'File'+ IntToStr(iCounter)+ '.htm';
        AssignFile (tfNewFile,szNewFile);
        ReWrite    (tfNewFile);

        //    html
        lnTitle := Format('%s%s%s%s%s%s%s',[sHead1,sSubject,sHead2,sSubject,' , ',sDate,sHead3]);
        WriteLn(tfNewFile, lnTitle);
        bTagOpen   := False;
        //ReadLn(tfDBFile,lnFile);
        lnFile := '';

        while Pos(sEOM,lnFile) = 0  do   //     
        begin

          //      1ah
          lnFile:=ReplaceStr(lnFile, '<', '&lt;');
          lnFile:=ReplaceStr(lnFile, chr(26), ' ');
          
          //     -    
          if Pos('>',lnFile) in[1..10]
          then begin
            if bTagOpen = False
            then begin
              WriteLn(tfNewFile,sTagOpen+lnFile);
              bTagOpen := True;
            end {if bTagOpen = False}
            else
              WriteLn(tfNewFile,lnFile);
          end {FindPart('>',lnFile) in[1..10]  then}

          else begin
            if bTagOpen = True
            then begin
              WriteLn(tfNewFile,sTagClose+lnFile);
              bTagOpen := False;
            end {if bTagOpen = True}
            else
              WriteLn(tfNewFile,lnFile);
          end; {FindPart('>',lnFile) in[1..10]  else}

          //   
          Readln(tfDBFile,lnFile);

          //     (    ,    )
          if lnFile = ''
          then begin
            WriteLn(tfNewFile,lnFile);
            ReadLn(tfDBFile,lnFile);
          end;  {if lnFile = ''}

          //   (   ,   )
          iECounter := 0;
          //ShowMessage('   ');
          while iECounter < Length(aExcludes)
          do begin
             //ShowMessage(lnFile);
             if Pos(aExcludes[iECounter],lnFile) = 1
             then begin
                 //ShowMessage(IntToStr(iECounter));
                 iECounter := 0;
                 ReadLn(tfDBFile,lnFile);
                 Continue;
             end
             else begin
               //ShowMessage('Not Found');
               Inc(iECounter);
             end;
          end; {for iECounter = 1 to len(aExcludes)}

          //    - ,    
          if Pos(sAttach, lnFile)> 0
            then begin
              //ShowMessage('Attach found,'#13#10+ szNewFile);
              break;
            end;

          //     - 
          if eof(tfDBFile) then break;

        end; {while FindPart(sEOM,lnFile) =0  do}

        //    ,    
        if bTagOpen = True then WriteLn(tfNewFile,sTagClose);

        //  html    
        WriteLn(tfNewFile,sEnd);
        CloseFile(tfNewFile);

      end; {while not eof(tfDBFile) do}
      
      CloseFile(tfDBFile);
      ShowMessage('Process complete, created '+ IntTOStr(iCounter)+ ' files');
    end; {Application.MessageBox([skip]) = IDOK}

end;

procedure TMainForm.ConvertTxt;
var
  lnFile    : String;       //    
  lnTitle   : String;       //  html 
  iCounter  : Integer;      //   
  bTagOpen  : Boolean;      //     
  sSubject  : String;       // Subj 
  sDate     : String;       //   
const
  //      :)
  sHead1    = '<html>'#13#10 +
              '<head>'#13#10 +
              '<title>';
  sHead2    = '</title>'#13#10 +
              '</head>'#13#10 +
              '<body text="#000099" bgcolor="#C0C0C0" link="#0000EE" vlink="#551A8B" alink="#FF0000">'#13#10 +
              '<pre>'#13#10 +
              '<b><font color="#006600">';
  sHead3    = '</font></b>';

  sEnd      = '</pre>'#13#10 +
              '</body>'#13#10 +
              '</html>'#13#10;

  sTagOpen  = '<b><font color="#990000">';
  sTagClose = '</font></b>';

  //   (  ) 
  sBOM      =  '=-=-=-=-=-=-=-=-=-=-=-=';

  //    
  sEOT      = '--------------------------------------------------------------------------------';
begin

    szDBFile   := DBFileNameEdit.Text;
    AssignFile (tfDBFile,szDBFile);
    Reset      (tfDBFile);

    iCounter    := 0;


    if Application.MessageBox('Process whith selected file ?','Confirmation',MB_OKCANCEL) = IDOK
    then begin

      while not eof(tfDBFile) do
      begin

        lnFile   := '';
        sSubject := 'Subj  ';
        sDate    := 'Date  ';
        
        while Pos(sEOT,lnFile) <> 1 do   //     
        begin
        
          ReadLn(tfDBFile,lnFile);

          if  Pos(' Subject:',lnFile) = 1
            then sSubject := ReplaceStr(lnFile, ' Subject:','');

          if  Pos('    Date:',lnFile) =1
            then sDate    := ReplaceStr(lnFile, '    Date:','');

        end; {while Pos(sBOT,lnFile) <> 1}

        //   
        Inc(iCounter);
        szNewFile  := 'File'+ IntToStr(iCounter)+ '.htm';
        AssignFile (tfNewFile,szNewFile);
        ReWrite    (tfNewFile);

        //    html
        lnTitle := Format('%s%s%s%s%s%s%s',[sHead1,sSubject,sHead2,sSubject,' , ',sDate,sHead3]);
        WriteLn(tfNewFile, lnTitle);
        bTagOpen   := False;
        lnFile := '';

        while Pos(sBOM,lnFile) = 0  do   //     
        begin

          //      1ah
          lnFile:=ReplaceStr(lnFile, '<', '&lt;');
          lnFile:=ReplaceStr(lnFile, chr(26), ' ');
          
          //     -    
          if Pos('>',lnFile) in[1..10]
          then begin
            if bTagOpen = False
            then begin
              WriteLn(tfNewFile,sTagOpen+lnFile);
              bTagOpen := True;
            end {if bTagOpen = False}
            else
              WriteLn(tfNewFile,lnFile);
          end {FindPart('>',lnFile) in[1..10]  then}

          else begin
            if bTagOpen = True
            then begin
              WriteLn(tfNewFile,sTagClose+lnFile);
              bTagOpen := False;
            end {if bTagOpen = True}
            else
              WriteLn(tfNewFile,lnFile);
          end; {FindPart('>',lnFile) in[1..10]  else}

          //   
          Readln(tfDBFile,lnFile);

          //     (    ,    )
          if lnFile = ''
          then begin
            WriteLn(tfNewFile,lnFile);
            ReadLn(tfDBFile,lnFile);
          end;  {if lnFile = ''}

          //     - 
          if eof(tfDBFile) then break;

        end; {while FindPart(sEOM,lnFile) =0  do}

        //    ,    
        if bTagOpen = True then WriteLn(tfNewFile,sTagClose);

        //  html    
        WriteLn(tfNewFile,sEnd);
        CloseFile(tfNewFile);

      end; {while not eof(tfDBFile) do}
      
      CloseFile(tfDBFile);
      ShowMessage('Process complete, created '+ IntTOStr(iCounter)+ ' files');
    end; {Application.MessageBox([skip]) = IDOK}


end;


end.
